diff --git a/app/test/Makefile b/app/test/Makefile
index 37a3772..39dd08e 100644
--- a/app/test/Makefile
+++ b/app/test/Makefile
@@ -120,6 +120,7 @@ endif
 SRCS-$(CONFIG_RTE_LIBRTE_METER) += test_meter.c
 SRCS-$(CONFIG_RTE_LIBRTE_KNI) += test_kni.c
 SRCS-$(CONFIG_RTE_LIBRTE_POWER) += test_power.c
+SRCS-$(CONFIG_RTE_LIBRTE_POWER_VM) += test_power_vm.c
 SRCS-y += test_common.c
 SRCS-$(CONFIG_RTE_LIBRTE_IVSHMEM) += test_ivshmem.c
 
diff --git a/app/test/autotest_data.py b/app/test/autotest_data.py
index 878c72e..5c6b60b 100644
--- a/app/test/autotest_data.py
+++ b/app/test/autotest_data.py
@@ -425,6 +425,19 @@ non_parallel_test_group_list = [
 	]
 },
 {
+	"Prefix" :      "power_vm",
+	"Memory" :      "512",
+	"Tests" :
+	[
+		{
+		 "Name" :       "Power VM  autotest",
+		 "Command" :    "power_vm_autotest",
+		 "Func" :       default_autotest,
+		 "Report" :     None,
+		},
+	]
+},
+{
 	"Prefix" :	"lpm6",
 	"Memory" :	"512",
 	"Tests" :
diff --git a/app/test/test_power_vm.c b/app/test/test_power_vm.c
new file mode 100644
index 0000000..176fbec
--- /dev/null
+++ b/app/test/test_power_vm.c
@@ -0,0 +1,215 @@
+/*-
+ *   BSD LICENSE
+ *
+ *   Copyright(c) 2010-2014 Intel Corporation. All rights reserved.
+ *   All rights reserved.
+ *
+ *   Redistribution and use in source and binary forms, with or without
+ *   modification, are permitted provided that the following conditions
+ *   are met:
+ *
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in
+ *       the documentation and/or other materials provided with the
+ *       distribution.
+ *     * Neither the name of Intel Corporation nor the names of its
+ *       contributors may be used to endorse or promote products derived
+ *       from this software without specific prior written permission.
+ *
+ *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <stdio.h>
+#include <stdint.h>
+#include <unistd.h>
+#include <limits.h>
+#include <string.h>
+
+#include "test.h"
+
+#include <rte_power.h>
+
+#define TEST_POWER_VM_LCORE_ID      0U
+#define TEST_POWER_VM_LCORE_INVALID 64U
+
+static int
+test_power_vm(void)
+{
+	int ret;
+
+	/* Test initialisation of invalid lcore */
+	ret = rte_power_init(TEST_POWER_VM_LCORE_INVALID);
+	if (ret != -1) {
+		printf("rte_power_init unexpectedly succeeded on an invalid lcore %u\n",
+				TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test initialisation of previously initialised lcore */
+	ret = rte_power_init(TEST_POWER_VM_LCORE_ID);
+	if (ret != 0) {
+		printf("rte_power_init unexpectedly failed on valid lcore %u,"
+				"please ensure that the environment has been configured "
+				"correctly and test application is running on a VM\n",
+				TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+	ret = rte_power_init(TEST_POWER_VM_LCORE_ID);
+	if (ret == 0) {
+		printf("rte_power_init unexpectedly succeeded on calling init twice on"
+				"lcore %u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency up of invalid lcore */
+	ret = rte_power_freq_up(TEST_POWER_VM_LCORE_INVALID);
+	if (ret == 0) {
+		printf("rte_power_freq_up unexpectedly succeeded on invalid lcore %u\n",
+				TEST_POWER_VM_LCORE_INVALID);
+		return -1;
+	}
+
+	/* Test frequency down of invalid lcore */
+	ret = rte_power_freq_down(TEST_POWER_VM_LCORE_INVALID);
+	if (ret == 0) {
+		printf("rte_power_freq_down unexpectedly succeeded on invalid lcore "
+				"%u\n", TEST_POWER_VM_LCORE_INVALID);
+		return -1;
+	}
+
+	/* Test frequency min of invalid lcore */
+	ret = rte_power_freq_min(TEST_POWER_VM_LCORE_INVALID);
+	if (ret == 0) {
+		printf("rte_power_freq_min unexpectedly succeeded on invalid lcore "
+				"%u\n", TEST_POWER_VM_LCORE_INVALID);
+		return -1;
+	}
+
+	/* Test frequency max of invalid lcore */
+	ret = rte_power_freq_max(TEST_POWER_VM_LCORE_INVALID);
+	if (ret == 0) {
+		printf("rte_power_freq_max unexpectedly succeeded on invalid lcore "
+				"%u\n", TEST_POWER_VM_LCORE_INVALID);
+		return -1;
+	}
+
+	/* Test frequency up of valid lcore */
+	ret = rte_power_freq_up(TEST_POWER_VM_LCORE_ID);
+	if (ret != 0) {
+		printf("rte_power_freq_up unexpectedly failed on valid lcore %u\n",
+				TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency down of valid lcore */
+	ret = rte_power_freq_down(TEST_POWER_VM_LCORE_ID);
+	if (ret != 0) {
+		printf("rte_power_freq_down unexpectedly failed on valid lcore "
+				"%u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency min of valid lcore */
+	ret = rte_power_freq_min(TEST_POWER_VM_LCORE_ID);
+	if (ret != 0) {
+		printf("rte_power_freq_min unexpectedly failed on valid lcore "
+				"%u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency max of valid lcore */
+	ret = rte_power_freq_max(TEST_POWER_VM_LCORE_ID);
+	if (ret != 0) {
+		printf("rte_power_freq_max unexpectedly failed on valid lcore "
+				"%u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test unsupported rte_power_freqs */
+	ret = rte_power_freqs(TEST_POWER_VM_LCORE_ID, NULL, 0);
+	if (ret != -ENOTSUP) {
+		printf("rte_power_freqs did not return the expected -ENOTSUP(%d) but "
+				"returned %d\n", -ENOTSUP, ret);
+		return -1;
+	}
+
+	/* Test unsupported rte_power_get_freq */
+	ret = rte_power_get_freq(TEST_POWER_VM_LCORE_ID);
+	if (ret != -ENOTSUP) {
+		printf("rte_power_get_freq did not return the expected -ENOTSUP(%d) but"
+				" returned %d for lcore %u\n",
+				-ENOTSUP, ret, TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test unsupported rte_power_set_freq */
+	ret = rte_power_set_freq(TEST_POWER_VM_LCORE_ID, 0);
+	if (ret != -ENOTSUP) {
+		printf("rte_power_set_freq did not return the expected -ENOTSUP(%d) but"
+				" returned %d for lcore %u\n",
+				-ENOTSUP, ret, TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test removing of an lcore */
+	ret = rte_power_exit(TEST_POWER_VM_LCORE_ID);
+	if (ret != 0) {
+		printf("rte_power_exit unexpectedly failed on valid lcore %u,"
+				"please ensure that the environment has been configured "
+				"correctly\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency up of previously removed lcore */
+	ret = rte_power_freq_up(TEST_POWER_VM_LCORE_ID);
+	if (ret == 0) {
+		printf("rte_power_freq_up unexpectedly succeeded on a removed "
+				"lcore %u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency down of previously removed lcore */
+	ret = rte_power_freq_down(TEST_POWER_VM_LCORE_ID);
+	if (ret == 0) {
+		printf("rte_power_freq_down unexpectedly succeeded on a removed "
+				"lcore %u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency min of previously removed lcore */
+	ret = rte_power_freq_min(TEST_POWER_VM_LCORE_ID);
+	if (ret == 0) {
+		printf("rte_power_freq_min unexpectedly succeeded on a removed "
+				"lcore %u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	/* Test frequency max of previously removed lcore */
+	ret = rte_power_freq_max(TEST_POWER_VM_LCORE_ID);
+	if (ret == 0) {
+		printf("rte_power_freq_max unexpectedly succeeded on a removed "
+				"lcore %u\n", TEST_POWER_VM_LCORE_ID);
+		return -1;
+	}
+
+	return 0;
+}
+
+static struct test_command power_vm_cmd = {
+    .command = "power_vm_autotest",
+    .callback = test_power_vm,
+};
+REGISTER_TEST_COMMAND(power_vm_cmd);
+